library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.numeric_std.ALL;
USE std.textio.all;

entity test is
end test;

architecture Behavioral of test is

component okrogi
 port(
   ap_clk : in std_logic;
   ap_rst : in std_logic;
   din : in std_logic_vector(31 downto 0);
   dx_V : in std_logic_vector(7 downto 0);
   dy_V : in std_logic_vector(7 downto 0);
   ap_return : out std_logic_vector(31 downto 0)
 );
end component;

 signal ap_clk : std_logic:= '0';
 signal ap_rst : std_logic;
 signal din : std_logic_vector(31 downto 0);
 signal xp : std_logic_vector(7 downto 0);
 signal yp : std_logic_vector(7 downto 0);
 signal dout : std_logic_vector(31 downto 0);
 constant T : time := 10 ns;
 signal sim : std_logic := '1';
begin

uut: okrogi port map (
     ap_clk => ap_clk,
     ap_rst => ap_rst,
     din => din,
     dx_V => xp,
     dy_V => yp,
     ap_return => dout
);

-- Clock generator
ap_clk_gen: process
begin
    if sim='1' then
		ap_clk <= '1';  wait for T/2;
		ap_clk <= '0';  wait for T/2;
    else
        wait;
    end if;
end process;

-- Stimulatorji za testiranje komponente
stim_proc: process
	variable xv, yv: std_logic_vector(7 downto 0);
	file slika: text open write_mode is "slika.txt";
	variable str: line;
	variable c: character;
	
function hex2chr(hex  : in std_logic_vector( 3 downto 0)) return character is
	 begin
		 case hex is
		  when "0000" =>    return '0'; 
          when "0001" =>    return '1'; 
          when "0010" =>    return '2'; 
          when "0011" =>    return '3'; 
          when "0100" =>    return '4'; 
          when "0101" =>    return '5'; 
          when "0110" =>    return '6'; 
          when "0111" =>    return '7'; 
          when "1000" =>    return '8'; 
          when "1001" =>    return '9'; 
          when "1010" =>    return 'a'; 
          when "1011" =>    return 'b'; 
          when "1100" =>    return 'c'; 
          when "1101" =>    return 'd'; 
          when "1110" =>    return 'e'; 
          when "1111" =>    return 'f';
          when others =>    return '*';
         end case;
end hex2chr;	
	
begin
	ap_rst <= '1'; din <= "00000000000000000000000000000000"; 
	xp <= "00000000"; 
	yp <= "00000000";
	wait for T;
    ap_rst <= '0';
	wait for T;
	
	for y in 40 downto 0 loop
	 yv := std_logic_vector(to_unsigned(y, 8));
	 for x in 0 to 150 loop
	  xv := std_logic_vector(to_unsigned(x, 8));
	  din <= X"80" & yv & xv & X"00"; 					-- barva ozadja je 0 
	  wait until rising_edge(ap_clk);
	  if dout(7 downto 0)=X"00" then  					-- izpis '.' pri izhodni barvi 0 ali
		write(str, character'('.'), right, 1);
	  else
	    write(str, hex2chr(dout(3 downto 0)), right, 1);  -- ...izpis spodnjih 4 bitov
	  end if;      
	 end loop;
	 writeline(slika, str);
	end loop;

	sim <= '0';
 wait;

end process;
end Behavioral;